recipes/urls.py
from django.urls import path


from recipes.views import (
    log_rating,
    RecipeListView,
    RecipeDetailView,
    RecipeCreateView,
    RecipeUpdateView,
    RecipeDeleteView,
    ShoppingItemListView,
    create_shopping_item,
    delete_all_shopping_items,
)

urlpatterns = [
    # Recipe
    path("", RecipeListView.as_view(), name="recipes_list"),
    path("<int:pk>/", RecipeDetailView.as_view(), name="recipe_detail"),
    path("new/", RecipeCreateView.as_view(), name="recipe_new"),
    path("<int:pk>/edit/", RecipeUpdateView.as_view(), name="recipe_edit"),
    path("<int:recipe_id>/ratings/", log_rating, name="recipe_rating"),
    path("<int:pk>/delete/", RecipeDeleteView.as_view(), name="recipe_delete"),
    # ShoppingItem
    path(
        "shopping_items/",
        ShoppingItemListView.as_view(),
        name="shopping_item_list"),
    path(
        "shopping_items/create/",
        create_shopping_item,
        name="shopping_item_create"),
    path(
        "shopping_items/delete/",
        delete_all_shopping_items,
        name="delete_all_shopping_items"),
]

scrumptious/urls.py
from django.contrib import admin
from django.urls import include, path, reverse_lazy
from django.views.generic.base import RedirectView

from django.contrib.auth import views as auth_views

urlpatterns = [
    path("admin/", admin.site.urls),
    path("recipes/", include("recipes.urls")),
    path("tags/", include("tags.urls")),
    path("meal_plans/", include("meal_plans.urls")),
    path(
        "",
        RedirectView.as_view(url=reverse_lazy("recipes_list")),
        name="home",
    ),
    path("accounts/login/", auth_views.LoginView.as_view(), name="login"),
    path("accounts/logout/", auth_views.LogoutView.as_view(), name="logout"),

]

tags/urls.py
from django.urls import path

from tags.views import (
    TagListView,
    TagDetailView,
    TagCreateView,
    TagUpdateView,
    TagDeleteView,
)

urlpatterns = [
    path("", TagListView.as_view(), name="tags_list"),
    path("<int:pk>/", TagDetailView.as_view(), name="tag_detail"),
    path("new/", TagCreateView.as_view(), name="tag_new"),
    path("<int:pk>/edit/", TagUpdateView.as_view(), name="tag_edit"),
    path("<int:pk>/delete/", TagDeleteView.as_view(), name="tag_delete"),
]

recipes/models.py
from django.db import models
from django.core.validators import MaxValueValidator, MinValueValidator

from django.conf import settings

USER_MODEL = settings.AUTH_USER_MODEL

# Create your models here.


# class Recipe -- we're going to inherit from models.Model
class Recipe(models.Model):
    name = models.CharField(max_length=125)
    author = models.ForeignKey(
        USER_MODEL,
        related_name="recipes",
        on_delete=models.CASCADE,
        null=True,
    )
        
    # TextField is an unlimited amount of text, no max cap
    description = models.TextField()
    
    # in our database it's going to say that it's ok if this field is empty
    # when we get to forms it's okay if this field is empty in the forms
    image = models.URLField(null=True, blank=True)

    created = models.DateTimeField(auto_now_add=True)
    updated = models.DateTimeField(auto_now=True)
    servings = models.PositiveSmallIntegerField(null=True)

    def __str__(self):
        return self.name


class Measure(models.Model):
    name = models.CharField(max_length=30, unique=True)
    abbreviation = models.CharField(max_length=10, unique=True)

    def __str__(self):
        return self.name


class FoodItem(models.Model):
    name = models.CharField(max_length=100, unique=True)

    def __str__(self):
        return self.name


class Ingredient(models.Model):
    recipe = models.ForeignKey(
        "Recipe",
        related_name="ingredients",
        on_delete=models.CASCADE
    )
    # to limit the amount of ingredients to 20
    amount = models.FloatField(
        validators=[MinValueValidator(1),MaxValueValidator(20)],
        )
    measure = models.ForeignKey(
        "Measure",
        on_delete=models.PROTECT
    )
    food = models.ForeignKey(
        "FoodItem",
        on_delete=models.PROTECT
    )

    def __str__(self):
        return str(self.amount) + " of " + str(self.food)


class Step(models.Model):
    # author changed to recipe_name in this case is the name of the Recipe
    recipe_name = models.ForeignKey(
        "Recipe",
        # what we would like to relate to -- in this case the recipe model
        related_name="steps",
        on_delete=models.CASCADE
    )
    order = models.SmallIntegerField()
    directions = models.TextField()
    food_items = models.ManyToManyField(
        "FoodItem",
        blank=True
    )

    def __str__(self):
        return str(self.recipe_name) + " step " + str(self.order)


class Rating(models.Model):
    value = models.PositiveSmallIntegerField(
        validators=[MinValueValidator(1),MaxValueValidator(5)]
    )
    recipe = models.ForeignKey(
        "Recipe",
        related_name="ratings",
        on_delete=models.CASCADE,
    )

    def __str__(self):
        return str(self.recipe) + " rating: " + str(self.value)


class ShoppingItem(models.Model):
    user = models.ForeignKey(
        USER_MODEL,
        related_name="shopping_items",
        on_delete=models.CASCADE,
        null=True,
    )
    food_item = models.ForeignKey(
        "FoodItem",
        on_delete=models.PROTECT,
    )

    def __str__(self):
        return f"{self.food_item} for {self.user}"

recipes/forms.py
from django import forms

from recipes.models import Rating


# create a form based on Rating
class RatingForm(forms.ModelForm):
    class Meta:
        model = Rating
        fields = ["value"]

recipes/views.py
from django.shortcuts import redirect

from django.urls import reverse_lazy

from django.views.generic.list import ListView
from django.views.generic.detail import DetailView
from django.views.generic.edit import CreateView, UpdateView, DeleteView

from django.contrib.auth.mixins import LoginRequiredMixin

from recipes.forms import RatingForm

# from recipes.forms import Recipe, ShoppingItem, Ingredient
from recipes.models import Recipe, ShoppingItem, Ingredient

# from django.views.decorators.http import require_http_methods
from django.db import IntegrityError


def log_rating(request, recipe_id):
    if request.method == "POST":
        form = RatingForm(request.POST)
        try:
            if form.is_valid():
                rating = form.save(commit=False)
                rating.recipe = Recipe.objects.get(pk=recipe_id)
                rating.save()
        except Recipe.DoesNotExist:
            return redirect("recipes_list")
    return redirect("recipe_detail", pk=recipe_id)


# def create_recipe(request):
#     if request.method == "POST" and RecipeForm:
#         form = RecipeForm(request.POST)
#         if form.is_valid():
#             recipe = form.save()
#             return redirect("recipe_detail", pk=recipe.pk)
#     elif RecipeForm:
#         form = RecipeForm()
#     else:
#         form = None
#     context = {
#         "form": form,
#     }
#     return render(request, "recipes/new.html", context)


class RecipeCreateView(LoginRequiredMixin, CreateView):
    model = Recipe
    template_name = "recipes/new.html"
    fields = ["name", "description", "image", "servings"]
    # after creating a new recipe, this will redirect folks
    # back to the home page
    success_url = reverse_lazy("recipes_list")

    # assign current logged in user as the author to any recipe that is made
    def form_valid(self, form):
        form.instance.author = self.request.user
        return super().form_valid(form)


# def change_recipe(request, pk):
#     if Recipe and RecipeForm:
#         instance = Recipe.objects.get(pk=pk)
#         if request.method == "POST":
#             form = RecipeForm(request.POST, instance=instance)
#             if form.is_valid():
#                 form.save()
#                 return redirect("recipe_detail", pk=pk)
#         else:
#             form = RecipeForm(instance=instance)
#     else:
#         form = None
#     context = {
#         "form": form,
#     }
#     return render(request, "recipes/edit.html", context)


class RecipeUpdateView(LoginRequiredMixin, UpdateView):
    model = Recipe
    template_name = "recipes/edit.html"
    fields = ["name", "description", "image", "servings"]
    success_url = reverse_lazy("recipes_list")


# def show_recipes(request):
#     context = {
#         "recipes": Recipe.objects.all() if Recipe else [],
#     }
#     return render(request, "recipes/list.html", context)


class RecipeListView(ListView):
    model = Recipe
    template_name = "recipes/list.html"
    # to add pagination to the page
    paginate_by = 3

    def get_queryset(self):
        # get_queryset inheriting from ListView parent class
        query = self.request.GET.get("q")
        if not query:
            # user input should be a string
            query = ""
        # from our listof all the recipes, filter out through our description
        # to see if it matches the query

        return Recipe.objects.filter(
            description__icontains=query,
        )


# def show_recipe(request, pk):
#     context = {
#         "recipe": Recipe.objects.get(pk=pk) if Recipe else None,
#         # to get the RatingForm on the page
#         "rating_form": RatingForm(),
#     }
#     return render(request, "recipes/detail.html", context)


class RecipeDetailView(DetailView):
    model = Recipe
    template_name = "recipes/detail.html"

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        # add our form to the context dictionary using the key
        # rating_form
        context["rating_form"] = RatingForm()

        # create a new empty foods list
        foods = []

        # for each item in user's shopping items
        for item in self.request.user.shopping_items.all():
            # add shopping item's food to the list
            foods.append(item.food_item)
        
        context["servings"] = self.request.GET.get("servings")

        # put that list into the context
        context["food_in_shopping_list"] = foods

        # return the context for Django to use
        return context


class RecipeDeleteView(LoginRequiredMixin, DeleteView):
    model = Recipe
    template_name = "recipes/delete.html"
    success_url = reverse_lazy("recipes_list")


class ShoppingItemListView(ListView):
    model = ShoppingItem
    template_name = "shopping_items/list.html"
    paginate_by = 3

    # filter shoppint items by logged in user
    def get_queryset(self):
        return ShoppingItem.objects.filter(user=self.request.user)


# # this view only handles HTTP POST requests
# @require_http_methods(["POST"])
def create_shopping_item(request):

    # get value of ingredient_id from the request.POST dictionary
    ingredient_id = request.POST.get("ingredient_id")

    # get specific ingredient from the ingredient model
    ingredient = Ingredient.objects.get(id=ingredient_id)

    # get the current user
    user = request.user
    try:
        # create the new shopping item in the database
        ShoppingItem.objects.create(food_item=ingredient.food, user=user)
    # catch the error if ingredient is saved in the database
    except IntegrityError:
        # don't do anything with the error
        pass

    # return to recipe page with a redirect
    return redirect("recipe_detail", pk=ingredient.recipe.id)


def delete_all_shopping_items(request):
    # delete all shopping item for the logged in user
    ShoppingItem.objects.filter(user=request.user).delete()
    return redirect("shopping_item_list")

recipes/templates/recipes/delete.html
{% extends 'base.html' %}

{% block content %}
  <main>
    <form method="post">
      {% csrf_token %}
      <p>Are you sure you want to delete "{{ recipe }}"?</p>
      {{ form.as_p }}
      <div class="control">
        <button class="button">Delete</button>
      </div>
    </form>
  </main>
{% endblock content %}

recipes/templates/recipes/detail.html
{% extends 'base.html' %}
{% load markdownify %}
{% comment %} loading the module name of resizer.py {% endcomment %}
{% load resizer %}


{% block content %}
  <main class="recipe-detail">
    {% comment %} Create link to Edit Recipe {% endcomment %}
    <div>
      <a href="{% url 'recipe_edit' recipe.id %}">Edit</a>
      <a href="{% url 'recipe_delete' recipe.id %}">Delete</a>
    </div>
    {% if recipe.image %}
      <img src="{{ recipe.image }}" class="pull-right">
    {% endif %}
    <h1>{{ recipe.name }}</h1>
    <h2>by: {{ recipe.author | default_if_none:"Unknown" }}</h2>
    <p>
      Created on {{ recipe.created }} |
      Updated on {{ recipe.updated }}
    </p>

    {% comment %} Servings {% endcomment %}
    {% if recipe.servings %}
      <p>
        Serves: {{ servings|default_if_none:recipe.servings }}
      </p>
      
      <form method="GET">
        <input required type="number" name="servings">
        <button>Resize</button>
      </form>

    {% endif %}

    {% comment %} Add the RatingForm so it shows up on the page {% endcomment %}
    <form method="post" action="{% url 'recipe_rating' recipe.id %}">
      {% csrf_token %}
      {{ rating_form.as_p }}
      <button class="button">Rate</button>
    </form>

    {% comment %} changed tag.word to tag.name {% endcomment %}
    <p>Tags: {% for tag in recipe.tags.all %} {{ tag.name }} {% endfor %}</p>
    <h2>Description</h2>
    {% comment %} remove paragraph tags and add "| markdownify" 
    to recipe.description {% endcomment %}
    {{ recipe.description | markdownify }}
    <h2>Ingredients</h2>
    <table>
      <thead>
        <tr>
          <th colspan="2">Amount</th>
          <th>Food item</th>
        </tr>
      </thead>
      <tbody>
        {% for ingredient in recipe.ingredients.all %}
          <tr>
            <td>{{ ingredient|resize_to:servings }}</td>
            <td>{{ ingredient.measure.name }}</td>
            <td>{{ ingredient.food.name }}</td>
            
            {% comment %} ShoppingItems custom HTML form {% endcomment %}
            <td>
              {% if ingredient.food not in food_in_shopping_list %}
                {% comment %} form method is POST because we're creating
                something (we use POST when creating, updating, or deleting something) 
                {% endcomment %}
                <form method="POST" action="{% url 'shopping_item_create' %}">
                  {% csrf_token %}
                  <input type="hidden" name="ingredient_id" value="{{ ingredient.id }}">
                  <button>+ My Shopping List</button>
                </form>
              {% else %}
                In your Shopping List
              {% endif %}
            </td>

          </tr>
        {% endfor %}
      </tbody>
    </table>
    <h2>Steps</h2>
    <ol>
      {% for step in recipe.steps.all %}
        <li>{{ step.directions }}</li>
      {% endfor %}
    </ol>
  </main>
{% endblock content %}

recipes/templates/recipes/edit.html
{% extends 'base.html' %}

{% block content %}
  <main class="recipe-form">
    <form method="post">
      {% comment %} security token {% endcomment %}
      {% csrf_token %}
      {% comment %} affects the layout, puts everything inside a paragraph tag {% endcomment %}
      {{ form.as_p }}
      <div class="control">
        <button class="button">Update</button>
      </div>
    </form>
  </main>
{% endblock content %}

recipes/templates/recipes/list.html
{% extends 'base.html' %}

{% block pagination %}
  <div class="pagination">
    <span class="step-links">
      {% if page_obj.has_previous %}  
          <a href="?page=1">&laquo; first</a>
          <a href="?page={{ page_obj.previous_page_number }}">previous</a>
      {% endif %}

      <span class="current">
        Page {{ page_obj.number }} of {{ page_obj.paginator.num_pages }}.
      </span>

      {% if page_obj.has_next %} 
        <a href="?page={{ page_obj.next_page_number }}">next</a>
        <a href="?page={{ page_obj.paginator.num_pages }}">last &raquo;</a>
      {% endif %}
    </span>
  </div>
{% endblock pagination %}

{% block content %}
  <main class="recipe-grid">
    {% comment %} the RecipeListView has added a different key to 
    the context for us to use, its recipe_list {% endcomment %}
    {% for recipe in recipe_list %}
      <div class="recipe-card">
        <h2 class="recipe-card-title">
          <a href="{% url 'recipe_detail' recipe.pk %}">{{ recipe.name }}</a>
        </h2>
        <p class="recipe-card-date">{{ recipe.updated }}</p>
      </div>
    {% endfor %}
  </main>
{% endblock content %}

recipes/templates/recipes/new.html
{% extends 'base.html' %}

{% block content %}
  <main class="recipe-form">
    <form method="post">
      {% comment %} security token {% endcomment %}
      {% csrf_token %}
      {% comment %} affects the layout, puts everything inside a 
      paragraph tag {% endcomment %}
      {{ form.as_p }}
      <div class="control">
        <button class="button">Create</button>
      </div>
    </form>
  </main>
{% endblock content %}